#!/bin/sh
#HDD-Check - Dateisystem-der Datenpartition der Dbox2-Festplatte ueberpruefen

version=0.7
name=DrStoned

if [ ! -f /var/etc/.start_ide ]; then
    msgbox title="Fehler" msg="~cIDE-Treiber nicht geladen !~n~c Bitte den IDE-Treiber in den Treiber- und Bootoptionen laden~n~c und die Dbox neu starten. "
    exit;
fi

reverse ()
{
    local _line
    while read -r _line ; do
        reverse
        echo "$_line"
        break
    done
}

sync

reverse < /proc/mounts | \
while read des fs type rest; do
    case "$type" in
        ext2)   touch /tmp/.ext2
        ;;
        ext3)   touch /tmp/.ext3
        ;;
        xfs)    touch /tmp/.xfs ; mkdir /hdd/lost+found
    esac
done

if [ -e /tmp/.ext2 ]; then
    t0=" ~Yfsck.ext2"
fi
if [ -e /tmp/.ext3 ]; then
    t0=" ~Yfsck.ext3"
fi
if [ -e /tmp/.xfs ]; then
    t0=" ~Yxfs_repair"
fi

msg()
{
msgbox  refresh=2 title="HDD-Check Version "$version" by "$name"" size=32 msg="$text" select="Bitte warten" &
}

text="~c Dieses Skript dient dazu, die Festplatte in der DBox zu ~uberpr~ufen.~n~n~c Zuerst wird ermittelt, mit welchem Dateisystem ~n~cdie Datenpartion der Festplatte gemounted wurde.~n~n~cDann wird die Datenpartition ungemountet und ~n~canschlieend das Dateisystem mit"$t0" ~S~uberpr~uft.~n~c Dieser Vorgang dauert ein paar Minuten.~n~n~s~n~c~Y Achtung: Eventuelle Fehler werden automatisch korrigiert~n~c~Y Die Dbox darf whrend des Festplattenchecks~n~c~Y nicht ausgeschaltet oder resettet werden !~n~c~ !!! Sonst droht Datenverlust !!!~n~s~n~n~c Festplattencheck starten?"

msgbox title="HDD-Check "$version" by "$name"" refresh=3 size=28 msg="$text" select="Nein,ja"
if [ $? -ne "2" ]; then
    msgbox title="HDD-Check" refresh=2 size=50 popup="Vorgang abgebrochen" timeout=3
    if [ -e /tmp/.ext2 ] ; then
        rm /tmp/.ext2
    fi
    if [ -e /tmp/.ext3 ] ; then
        rm /tmp/.ext3
    fi
    if [ -e /tmp/.xfs ] ; then
        rm /tmp/.xfs
    fi
    exit;
fi
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Dateisystem ermitteln~n~l O Datenpartiton unmounten~n~l O Datenpartiton ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l~G X Dateisystem ermitteln~n~l O Datenpartiton unmounten~n~l O Datenpartiton ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"

#Daemons, die von der Festplatte gestartet wurden, abschalten

killall -9 smbd
killall -9 nmbd
sleep 2

msg
umount /hdd
sleep 1
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Dateisystem ermitteln~n~l~G O Datenpartiton unmounten~n~l O Datenpartiton mit"$t0" ~S~ ~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"

msg
sleep 1
if [ -e /hdd/lost+found/ ] ; then
    killall msgbox
    msgbox title="Fehler" refresh=2 popup="~Y~c!!! Die Datenpartiton konnte nicht ungemountet werden !!!~n~n~c M~oglicherweise l~auft noch ein Programm auf der Festplatte,~n~c das nicht beendet wurde. " timeout=7
    if [ -e /tmp/.ext2 ] ; then
        rm /tmp/.ext2
    fi
    if [ -e /tmp/.ext3 ] ; then
        rm /tmp/.ext3
    fi
    if [ -e /tmp/.xfs ] ; then
        rm /tmp/.xfs
    fi
    exit;
fi
sleep 1
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Dateisystem ermitteln~n~l X Datenpartiton unmounten~n~l~G O Datenpartiton mit"$t0" ~G~uberpr~ufen~n~l O mounte Datenpartition nach /hdd~n~l O Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg

if [ -e /tmp/.ext2 ]; then
    fsck.ext2 -fvy /dev/ide/host0/bus0/target0/lun0/part2 > /tmp/fsck.log ;
    echo ~BDateisystem mit~Y"$t0" ~Bgepr~uft am `date "+%d.%m.%Y  %H:%M Uhr ~Y! Bitte warten !"` >> /var/etc/fsck.log ;
    /bin/mount -t ext2 /dev/ide/host0/bus0/target0/lun0/part2 /hdd ;
    rm /tmp/.ext2
elif [ -e /tmp/.ext3 ]; then
    fsck.ext3 -fvy /dev/ide/host0/bus0/target0/lun0/part2 > /tmp/fsck.log ;
    echo ~BDateisystem mit~Y"$t0" ~Bgepr~uft am `date "+%d.%m.%Y  %H:%M Uhr ~t~Y! Bitte warten !"` >> /var/etc/fsck.log ;
    /bin/mount -t ext3 /dev/ide/host0/bus0/target0/lun0/part2 /hdd ;
    rm /tmp/.ext3
elif [ -e /tmp/.xfs ]; then
    xfs_repair -v /dev/ide/host0/bus0/target0/lun0/part2 > /tmp/fsck.log ;
    echo ~BDateisystem mit~Y"$t0" ~Bgepr~uft am `date "+%d.%m.%Y  %H:%M Uhr ~t~Y! Bitte warten !"` >> /var/etc/fsck.log ;
    /bin/mount -t xfs /dev/ide/host0/bus0/target0/lun0/part2 /hdd ;
    rm /tmp/.xfs
else
    killall msgbox
    msgbox title="Fehler" refresh=2 size=30 popup="~Y~c!!! Das Dateisystem der Datenpartiton konnte nicht festgestellt werden !!! ~n~c Vermutlich war die Datenpartiton nicht gemounted. " timeout=7
    exit;
fi
sleep 1

# Daemons, die auf der Platte laufen, wieder laden

if [ -e /var/etc/.samba ]; then

 /hdd/bin/nmbd -D
 /hdd/bin/smbd -D

fi;
sleep 2

text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Dateisystem ermitteln~n~l X Datenpartiton unmounten~n~l X Datenpartiton mit"$t0" ~S~uberpr~uft~n~l~G O mounte Datenpartition nach /hdd~n~l O Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Dateisystem ermitteln~n~l X Datenpartiton unmounten~n~l X Datenpartiton mit"$t0" ~S~uberpr~uft~n~l X mounte Datenpartition nach /hdd~n~l~G O Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
text="~c~Y!!! HDD-Check, bitte warten !!!~n~s~n~l X Dateisystem ermitteln~n~l X Datenpartiton unmounten~n~l X Datenpartiton mit"$t0" ~S~uberpr~uft~n~l X mounte Datenpartition nach /hdd~n~l~G X Ergebnis anzeigen~n~s~n~cDieser Vorgang dauert ein paar Minuten~n~s"
msg
sleep 1
msgbox title="Ergebnis HDD-Check  ! Bitte warten !" refresh=2 size=26 popup=/tmp/fsck.log timeout=10 ;
msgbox title="HDD-Check" refresh=2 size=50 popup="HDD-Check beendet" timeout=3 ;
killall msgbox
exit 0